
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Assessment_resultsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const assessment_results = await db.assessment_results.create(
            {
                id: data.id || undefined,
        
        score: data.score
        ||
        null
            ,
            
        grade_letter: data.grade_letter
        ||
        null
            ,
            
        remarks: data.remarks
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await assessment_results.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await assessment_results.setAssessment( data.assessment || null, {
            transaction,
        });
        
        await assessment_results.setStudent( data.student || null, {
            transaction,
        });
        

        

        

        return assessment_results;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const assessment_resultsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                score: item.score
            ||
            null
            ,
            
                grade_letter: item.grade_letter
            ||
            null
            ,
            
                remarks: item.remarks
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const assessment_results = await db.assessment_results.bulkCreate(assessment_resultsData, { transaction });

        // For each item created, replace relation files
        

        return assessment_results;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const assessment_results = await db.assessment_results.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.score !== undefined) updatePayload.score = data.score;
        
        
        if (data.grade_letter !== undefined) updatePayload.grade_letter = data.grade_letter;
        
        
        if (data.remarks !== undefined) updatePayload.remarks = data.remarks;
        
        
        updatePayload.updatedById = currentUser.id;

        await assessment_results.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await assessment_results.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.assessment !== undefined) {
            await assessment_results.setAssessment(
              
              data.assessment,
              
              { transaction }
            );
        }
        
        if (data.student !== undefined) {
            await assessment_results.setStudent(
              
              data.student,
              
              { transaction }
            );
        }
        

        
        

        

        return assessment_results;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const assessment_results = await db.assessment_results.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of assessment_results) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of assessment_results) {
                await record.destroy({transaction});
            }
        });


        return assessment_results;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const assessment_results = await db.assessment_results.findByPk(id, options);

        await assessment_results.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await assessment_results.destroy({
            transaction
        });

        return assessment_results;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const assessment_results = await db.assessment_results.findOne(
            { where },
            { transaction },
        );

        if (!assessment_results) {
            return assessment_results;
        }

        const output = assessment_results.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await assessment_results.getOrganization({
            transaction
        });
        
        
        output.assessment = await assessment_results.getAssessment({
            transaction
        });
        
        
        output.student = await assessment_results.getStudent({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.assessments,
        as: 'assessment',
        
        where: filter.assessment ? {
          [Op.or]: [
            { id: { [Op.in]: filter.assessment.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.assessment.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.students,
        as: 'student',
        
        where: filter.student ? {
          [Op.or]: [
            { id: { [Op.in]: filter.student.split('|').map(term => Utils.uuid(term)) } },
            {
              student_number: {
                [Op.or]: filter.student.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.remarks) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'assessment_results',
                        'remarks',
                        filter.remarks,
                    ),
                };
            }
            

            
            

            
            if (filter.scoreRange) {
                const [start, end] = filter.scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.grade_letter) {
                where = {
                    ...where,
                grade_letter: filter.grade_letter,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.assessment_results.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'assessment_results',
                        'grade_letter',
                        query,
                    ),
                ],
            };
        }

        const records = await db.assessment_results.findAll({
            attributes: [ 'id', 'grade_letter' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['grade_letter', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.grade_letter,
        }));
    }

    
};

